;compile with ajasmplus
	device zxspectrum128
        ORG #6000
begin
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr
	ld a,$10,bc,$7ffd:out (c),a
	out ($FE),a
gamebeg:
; init vars
	ld hl,0,(maxx+1),hl,(tp+1),hl
	ld a,31,(tuc+1),a
	call blackscr
;zero memory
	ld hl,$C000
	xor a
zm:
	ld (hl),a
	inc hl
	cp h
	jr nz,zm

;build lut tile adresses 512bytes
ta=$BE00
	ld hl,ta
blut:
	push hl
	ld h,0
	res 7,l
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl;*32
	ld de,gt
	add hl,de
	ex de,hl
	pop hl
	ld (hl),e:inc h
	ld (hl),d:dec h
	inc l
	jr nz,blut
;generate lvl
	ld ixh,$C0
ylp:
	ld ixl,0
xlp:
	call rnd
	and 3
	ld (ix+0),a
	inc ix
	ld a,ixl
	and 15
	jr nz,xlp
	inc ixh
	ld a,ixh
	cp $CC
	jp nz,ylp
	
;	jr $
	call drawl
	call whitescr
	ld de,0,(cxy),de
	call crs
	
	call nomax
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
glp:
;	call roll
	ld de,(cxy)
 ld a,$F7:in a,(#FE):and 16:jp z,left;5 is left
;O
 ld a,$DF:in a,(#FE):and 2:jp z,left

 ld a,$EF:in a,(#FE):and 4:jp z,right;8 is right
;P
 ld a,$DF:in a,(#FE):and 1:jp z,right

 ld a,$EF:in a,(#FE):and 8:jp z,up;7 is up
;Q
 ld a,$FB:in a,(#FE):and 1:jp z,up

 ld a,$EF:in a,(#FE):and 16:jp z,down;6 is down
;A
 ld a,$FD:in a,(#FE):and 1:jp z,down

; Fire
;0
	ld a,$EF:in a,($FE):and 1:jp z,fireon
;En
	ld a,$BF:in a,($FE):and 1:jp z,fireon
;Sp
	ld a,$7F:in a,($FE):and 1:jp z,fireon
;M
	ld a,$7F:in a,($FE):and 4:jp z,fireon

	jp glp
endk:
	ei:halt:halt:halt:halt
	ld (cxy),de
	jp glp
cxy: dw 0; DE=y,x
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
left:
	ld a,e:or a:jp z,glp
	call crs
	dec e
	call crs
;	ei:halt:halt:halt:halt
;	call wp
	jp endk
right:
	ld a,e:cp 15:jp z,glp
	call crs
	inc e
	call crs
;	ei:halt:halt:halt:halt
;	call wp
	jp endk
up:
	ld a,d:or a:jp z,glp
	call crs
	dec d
	call crs
;	ei:halt:halt:halt:halt
;	call wp
	jp endk
down:
	ld a,d:cp 11:jp z,glp
	call crs
	inc d
	call crs
;	ei:halt:halt:halt:halt
;	call wp
	jp endk
fireon:
	call crs
	ld ixl,e
	ld a,d
	or $C0
	ld ixh,a
	ld a,(ix+16)
	bit 7,a
	jp nz,glp
	ld a,(ix+0)
	call mul32
	ld (ix+16),a

	ld hl,0,(tp+1),hl
	call roll

	ld de,(cxy)
	call crs

; 
tuc:
	ld a,32
	dec a
	ld (tuc+1),a
	push af
	ld l,a,h,0
	
	ld de,pscore
	call DispHL
	
	ld a,2*8+7,(chco+1),a
	ld de,$5A03
	call chgo
	ld a,3*8+7,(chco+1),a

	pop af

	jp nz,glp

	ld hl,gameover
	ld de,$4800+4*32+3
prgo:
	push hl
	ld l,(hl),h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,fnt-256:add hl,bc
	push de
pr8:
	ld a,(hl),(de),a:inc hl,d
	ld a,d:and 7:jr nz,pr8
	pop de:inc e

	pop hl:inc hl
	ld a,(hl):or a:jp nz,prgo
;attrib:
	ld hl,$5900+4+4*32
	ld b,27
atrlp:
	ld (hl),$44
	inc hl
	djnz atrlp

testk:
;Y
	ld a,$DF: in a,($FE):and 16:jp z,gamebeg
;N
	ld a,$7F: in a,($FE):and 8:jp z,0

	jr testk
gameover:
	db " Game over. Play Again?(Y/N) ",0
ccol=8
crs:
;	ei:halt
	push de
	ld l,d
	add hl,hl
	add hl,hl;2
	add hl,hl;4
	ld h,11
	add hl,hl
	add hl,hl
	add hl,hl
	ld d,0
	add hl,de
	add hl,de
	push hl:pop ix
	ld a,(ix+0):xor ccol:ld (ix+0),a
	ld a,(ix+1):xor ccol:ld (ix+1),a
	ld a,(ix+32):xor ccol:ld (ix+32),a
	ld a,(ix+33):xor ccol:ld (ix+33),a
	pop de
	ret
;[[[[[[[[[[[[[[[[[[[[[[ routines]]]]]]]]]]]]]]]]]]]]]]]]]

roll:;roll all sprites
;check available
	ld ixh,$C0
chy:
	ld ixl,0
chx:
	ld a,(ix+16)
	and 128:jp nz,foundr
	inc ixl
	ld a,ixl
	and 15
	jr nz,chx
	inc ixh
	ld a,ixh
	cp $CC
	jr nz,chy
;==========================================================================================
; . 
maxx: ld hl,0
	ld de,(tp+1)
	or a:sbc hl,de
	jr nc,nomax
	ld (maxx+1),de
nomax:
	ld hl,(maxx+1)
	ld de,pscore
	call DispHL
;output to screen
	ld de,$5800+3
chgo:
	ld hl,pscore
	ld a,128,(chb+1),a
	ld b,5

ch5:
	push hl
	ld l,(hl)
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	push bc
	ld bc,fnt-256
	add hl,bc
	pop bc
	
ch_letr:
	push de
	push hl
	ld c,8
ch8:
	ld a,(hl)
chb: and 128
	ld a,7
	jr z,chput
chco:	ld a,3*8+7
chput:
	ld (de),a
	ld a,e:add a,32:ld e,a
	ld a,d:adc a,0:ld d,a
	inc hl
	dec c:jr nz,ch8

	pop hl,de
	inc e
	ld a,(chb+1)
	srl a
	ld (chb+1),a
	cp 4:jp nz,ch_letr
	ld a,128,(chb+1),a
	pop hl:inc hl
	djnz ch5;dec b:jp nz,
	ret

;Number in hl to decimal ASCII
;Thanks to z80 Bits
;inputs:	hl = number to ASCII
;example: hl=300 outputs '00300'
;destroys: af, bc, hl, de used
DispHL:
	ld	bc,-10000
	call	Num1
	ld	bc,-1000
	call	Num1
	ld	bc,-100
	call	Num1
	ld	c,-10
	call	Num1
	ld	c,-1
Num1:	ld	a,'0'-1
Num2:	inc	a
	add	hl,bc
	jr	c,Num2
	sbc	hl,bc
	;call PUTCHAR
	ld (de),a:inc de
	ret
pscore: ds 8

foundr:
;	ld a,1:out ($FE),a
	ei:halt;:halt;:halt:halt

;lets roll
	ld ixh,$C0
roly:
	ld ixl,0
rolx:
	ld a,(ix+16)
	bit 7,a:jp z,nextro
	ld l,a
	ld h,ta/256
	ld a,(hl):inc h:ld h,(hl),l,a
;precalc screenadress
	ld a,ixl
	add a,a
	ld e,a
	ld a,ixh
	and $0F
	add a,a
	ld d,a
	
	push hl
		ld	hl, 4000h
		ld	a, d
		and	18h
		or	h
		ld	h, a
		ld	a, d
		and	7
		ld	d, a
		srl	d
		rr	l
		srl	d
		rr	l
		srl	d
		rr	l
		add	hl, de
		ex de,hl
		pop hl
		ld (deadr+1),de
	call dr16x16
	
	;jr $
	ld a,(ix+16)
	inc a
;	or 128;+
	ld (ix+16),a
	and 31
	jr nz,nextro
	ld (ix+16),0
	ld a,(ix+0)
	inc a
	and 3
	ld (ix+0),a
	add a,a
	add a,a
	add a,a
	add a,a
	add a,a
	ld l,a,h,ta/256
	ld a,(hl):inc h:ld h,(hl),l,a
deadr:ld de,0
	call dr16x16
	call analyz
nextro:
	inc ixl
	ld a,ixl
	and 15
	jp nz,rolx
	inc ixh
	ld a,ixh
	cp $CC
	jr nz,roly
	jp roll;ret
analyz:
	ld a,(ix+0)
	or a:jp z,case_0
	dec a:jp z,case_1
	dec a:jp z,case_2
	dec a:jp z,case_3
	ret;jr $

adds:
	push af,bc,de,hl
;score++
tp:ld hl,0
	inc hl
	ld (tp+1),hl
	call ay1
	pop hl,de,bc,af
	ret
ay1:
	nop
		ld	hl, aydump;unk_89F4
		ld	a, 0Dh
		ld	c, 0FDh

loc_89E6:
out_ay:
		ld	b, 0FFh
		out	(c), a
		ld	b, 0BFh
		outi
		dec	a
		jp	p,out_ay; loc_89E6
		ret
aydump:
;unk_89F4:
	db    1
		db    4
		db    0
		db  10h
		db  10h
		db  10h
		db    0
		db    1
		db  20h
		db  60h	; `
		db  20h
		db 0E0h	; 
		db  20h
		db  70h	; p
		db    0			; end

case_0:
;8:16 05.09.2018    ,       - 
;11:08 05.09.2018    ,  
;9:18 06.09.2018    
; 0->12
;23
	ld a,ixl:cp 15:jr z,case_01;  
	bit 7,(ix+17):jr nz,case_01
	ld a,(ix+1)
	cp 1:jr z,case_02
	cp 2:jr nz,case_01
case_02:
	call mul32
	ld (ix+17),a
	
	call adds

case_01:
	ld a,ixh:cp $CB:ret z;   
	inc ixh
	ld a,(ix+0)
	dec ixh
	cp 2:jr z,case_03
	cp 3:ret nz
case_03:
	call mul32
	inc ixh
	bit 7,(ix+16):jr nz,case_04
	ld (ix+16),a

	call adds

case_04:
	dec ixh
	ret
mul32:
	add a,a
	add a,a
	add a,a
	add a,a
	add a,a
	or 128
	ret

case_1:
 ;30<-1
;    23
	ld a,ixl:or a:jr z,case_11; 
	bit 7,(ix-1):jr nz,case_11
	ld a,(ix-1)
	cp 3:jr z,case_10
	or a:jr nz,case_11
case_10:
	call mul32
	ld (ix+15),a

	call adds

case_11:
	ld a,ixh:cp $CB:ret z;  
	inc ixh
	ld a,(ix+0)
	dec ixh
	cp 2:jr z,case_13
	cp 3:ret nz
case_13:
	inc ixh
	bit 7,(ix+16):jr nz,case_12; , 
	call mul32
	ld (ix+16),a

	call adds

case_12:
	dec ixh
	ret

case_2:
;    10
;03<-2
;	jr $
;  
	ld a,ixl:or a:jr z,case_22
	bit 7,(ix-1):jr nz,case_22
	ld a,(ix-1)
	cp 3:jr z,case_24
	or a:jr nz,case_22
case_24:
	call mul32
	ld (ix+15),a

	call adds

case_22:
;   
	ld a,ixh:cp $C0:ret z
	dec ixh
	ld a,(ix+0)
	inc ixh
	cp 1:jr z,case_25
	or a:ret nz
case_25:
	dec ixh
	bit 7,(ix+16):jr nz,case_23; 
	call mul32
	ld (ix+16),a

	call adds

case_23:
	inc ixh
	ret

case_3:
;01
; 3->21
	ld a,ixl:cp 15:jr z,case_31;  
	bit 7,(ix+17):jr nz,case_31
	ld a,(ix+1)
	cp 2:jr z,case_32
	cp 1:jr nz,case_31
case_32:
	call mul32
	ld (ix+17),a

	call adds

case_31:

;   
	ld a,ixh:cp $C0:ret z
	dec ixh
	ld a,(ix+0)
	inc ixh

	dec ixh
	bit 7,(ix+16):jr nz,case_33; 
	cp 1:jr z,case_34
	or a:jr nz,case_33
case_34:
	call mul32
	ld (ix+16),a

	call adds

case_33:
	inc ixh
	ret

dr16x16:
	call dr16
	ex de,hl
	ld bc,$F820
	add hl,bc
	ex de,hl
dr16:
 dup 8
 ldi
 ld a,(hl),(de),a
 inc hl
 dec e
 inc d
edup
	ret
wk:;wait keypressed
	xor a
	in a,($fe)
	cpl
	and 31
	jr z,wk
	ret
wp: ;wait until pressed
	xor a
	in a,($FE)
	cpl
	and 31
	jr nz,wp
	ret

drawl:
	ld de,$4000
	ld ixh,$C0
dry:
	ld ixl,0
drx:
;	ei:halt

	ld l,(ix+0)
;	ld l,3
	ld h,0
	add hl,hl
	ld bc,ttab ; original position
	add hl,bc
	ld a,(hl):inc hl
	ld h,(hl),l,a
	
	ld b,16
	push de
dr1:
	ld a,(hl),(de),a:inc hl,e
	ld a,(hl),(de),a:inc hl:dec e
	call nbde
	djnz dr1

	pop de

	inc e,e
	inc ix
	ld a,ixl
	and 15
	jp nz,drx
	inc ixh
	ld a,e
	add a,32
	ld e,a
	sbc a,a
	and 8
	add a,d
	ld d,a
	cp $58
	jp nz,dry
	ret
ttab:
	dw gt,gt+32*32,gt+64*32,gt+96*32
;--------???? ?? ??????? ??  hl,de--------------------------
nbde    INC D:LD A,D:AND 7:RET NZ
        LD A,E:ADD A,#20:LD E,A:RET C
        LD A,D:SUB 8:LD D,A:RET
        
whitescr:ld a,7:jr blackscr+1
blackscr: xor a
	ld hl,$5800,de,$5801,bc,767,(hl),a:ldir
	ret
; 16 bit random number routine I found on the web
; Returns a pseudo-random number in the HL register
;
;Rand16_Seed:		EQU 12345
rnd:
	push hl,de
Rand16:			LD DE,12345;Rand16_Seed
			LD A,D
			LD H,E
			LD L,253
			OR A
			SBC HL,DE
			SBC A,0
			SBC HL,DE
			LD D,0
			SBC A,D
			LD E,A
			SBC HL,DE
			JR NC,Rand16_1
			INC HL
Rand16_1:		LD (Rand16+1),HL
	ld a,l
	pop de,hl
			RET
gt:incbin "gridt2.bin"
fnt:incbin "grid.fnt"

end
	display /d,end-begin
	savesna "!void.sna",begin
	savebin "gridi.code",begin,end-begin

